/**
 * Copyright (c) 2006-2009 Institut National de Recherche en Informatique et 
 *                         en Automatique. All rights reserved.
 * $COPYRIGHT$
 * 
 * Additional copyrights may follow
 * 
 * $HEADER$
 */

//gsoap ns service name: service
//gsoap ns service style: rpc
//gsoap ns service encoding: literal
//gsoap ns schema namespace: urn:service


enum TAG {ORTE, OMPI};
typedef enum TAG TAG_t;

enum TRAVERSING_CODE{
  direct = 1,
    proxy,
    tcp_traversing,
    };
typedef enum TRAVERSING_CODE TRAVERSING_CODE_t;


struct sockaddr_t {
  char *host_name; 
  char *host_ip; 
  unsigned short port;
  TRAVERSING_CODE_t traversing_code;
  char *response;
};

typedef struct sockaddr_t sockaddr_t;
typedef struct sockaddr_t ns__uriResponse;

typedef int32_t cellid_t;
typedef int32_t jobid_t;
typedef int32_t vpid_t;
typedef int32_t taskid_t;

struct process_name_t {
    cellid_t cellid;
    jobid_t jobid;
    vpid_t vpid;
    taskid_t taskid;

};
typedef struct process_name_t process_name_t;

// prototype of the functions implemented
int ns__getHostURI(process_name_t *proc_name, process_name_t *my_name, sockaddr_t *uri_A, TAG_t tag, ns__uriResponse  *uri_B);
int ns__putMyURI(process_name_t *proc_name, sockaddr_t *uri_B, TAG_t tag, struct ns__noResponse {} *out); 

int ns__update_broker(int *number, struct ns__noResponse  *out); 
int ns__update_frontale(int *number, struct ns__noResponse  *out);
int ns__update_connection_helper(int *number, struct ns__noResponse  *out); 
int ns__proxy_connection_demande(char *demande, struct ns__noResponse  *out);
int ns__proxy_port(int *proxy_port, struct ns__noResponse  *out);
int ns__service_proxy_port(int *service_proxy_port, struct ns__noResponse  *out);
int ns__get_proxy_uid(int *uid);
int ns__forward_syn_data(char *data, struct ns__noResponse  *out);
int ns__start_traversing(char *local_ip, int *local_port, struct ns__noResponse  *out);
int  ns__delete_data(int *taskid);  
